Bug 970223 - Feature 'Yum Groups as Objects' might need to be reverted (several issues)
Feature 'Yum Groups as Objects' might need to be reverted (several issues)
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
19
x86_64 Linux
unspecified Severity high
: ---
: ---
Assigned To: James Antill
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-03 14:28 EDT by Reartes Guillermo
Modified: 2015-02-17 10:26 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 10:26:33 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Reartes Guillermo 2013-06-03 14:28:24 EDT
Description of problem:

Feature: "Yum Groups as Objects" Status

The Feature changes default 'group_command=compat' to 'group_command=objects'
If no 'group_command=' is set in /etc/yum.conf, 'objects' is the new default value.

The yum.conf man page is outdated and does still shows 'compat' as the default value. (Issue #0, Reported in Bug 970220)

If one sets 'group_command=compat' in /etc/yum.conf right after installing F19b RC4, one will not experience any of these issues (1,2,3,4). This does indeed revert back the feature 'Yum Groups as Objects'.

These issues might not look too bad on their own, but together shows that the feature "Yum Groups as Objects" is not as ready as it seems. Yum being a central piece of the distribution, please review if this feature can be fixed (or postponed for F20 if it cannot be fixed).

I will mark issues 0,1,2,3,4 as blocking this and mark this bug-report as a FE proposal.

Version-Release number of selected component (if applicable):
F19b RC4
yum 3.4.3-91.fc19

How reproducible:
always
Comment 1 Reartes Guillermo 2013-06-03 14:29:07 EDT
Issue #1: yum 'group install' gives an exception at the end of 'verify' phase:

# yum group install 'LXDE Destkop'

* Bug 928859 
  “yum groupinstall kde-desktop-environment” prints an error message

After installing F19b RC4, the first execution of a 'yum group install'
command results in yum giving an exception at the VERIFY phase.

Typical Error:

# yum group install 'LXDE Desktop' -y
[...TRUNCATED OUTPUT...]
Traceback (most recent call last):
  File "/usr/bin/yum", line 29, in <module>
    yummain.user_main(sys.argv[1:], exit_code=True)
  File "/usr/share/yum-cli/yummain.py", line 316, in user_main
    errcode = main(args)
  File "/usr/share/yum-cli/yummain.py", line 219, in main
    return_code = base.doTransaction()
  File "/usr/share/yum-cli/cli.py", line 697, in doTransaction
    if have_reinstalls:
  File "/usr/lib/python2.7/site-packages/yum/__init__.py", line 1763, in runTransaction
    self.history.end(rpmdbv, 2, errors=herrors)
  File "/usr/lib/python2.7/site-packages/yum/igroups.py", line 148, in save
    if not os.path.exists(db_path):
  File "/usr/lib/python2.7/site-packages/yum/igroups.py", line 175, in _write_grp_grps
    
KeyError: '3d-printing'

The 'KeyError' value changes depending of the Group chosen.

Performing a 'yum update' before a 'yum group install' makes the issue
go away. One cannot be sure if it was fixed or just workaround-ed at the package level, since the yum version is the same before and after the package updates.

Seting 'group_command=compat' in yum.conf after the first boot workarounds
the issue. The first 'group install' finishes ok.
Comment 2 Reartes Guillermo 2013-06-03 14:29:51 EDT
Issue #2: 'group remove' fails because the group 'is not installed'

# yum group remove 'LXDE Desktop'

With yum.conf default 'group_command=objects' (aka leave yum.conf untouched) one
can install groups. The first one will hit issue #1, the rest will not.
In the example, i installed LXDE Desktop, then Visualization and then KDE Plasma Workspaces. When i tried to remove group Visualization, i got a yum.conf exception.

The issue disappears if one setups yum.conf setting 'group_command=compat' and then retries the group uninstall action.

Typical Error:

# yum group remove virtualization
Loaded plugins: langpacks, refresh-packagekit
No environment named virtualization exists
Traceback (most recent call last):
  File "/usr/bin/yum", line 29, in <module>
    yummain.user_main(sys.argv[1:], exit_code=True)
  File "/usr/share/yum-cli/yummain.py", line 316, in user_main
    errcode = main(args)
  File "/usr/share/yum-cli/yummain.py", line 126, in main
    result, resultmsgs = base.doCommands()
  File "/usr/share/yum-cli/cli.py", line 522, in doCommands
    return self.yum_cli_commands[self.basecmd].doCommand(self, self.basecmd, self.extcmds)
  File "/usr/share/yum-cli/yumcommands.py", line 1047, in doCommand
    return base.removeGroups(extcmds)
  File "/usr/share/yum-cli/cli.py", line 1961, in removeGroups
    txmbrs = self.groupRemove(group.groupid)
  File "/usr/lib/python2.7/site-packages/yum/__init__.py", line 3566, in groupRemove
    igroup_data = self._groupInstalledData(thisgroup)
  File "/usr/lib/python2.7/site-packages/yum/__init__.py", line 3351, in _groupInstalledData
    for pkg_name in set(group.packages + list(pkg_names)):
AttributeError: 'InstalledGroup' object has no attribute 'packages'

Reported in:

* Bug 968840
  [abrt] yum-3.4.3-91.fc19: __init__.py:3351:_groupInstalledData:AttributeError: 'InstalledGroup' object has no attribute 'packages' 
  
Additional Bug-Reports:

* Bug 955236
  [abrt] yum-3.4.3-83.fc20: cli.py:1945:removeGroups:AttributeError: 'InstalledGroup' object has no attribute 'groupid' 
  >> in this bug-report the yum exception is different. i did not reproduce this.
  >> Comment #6 exceptio differs from the Description one.
Comment 3 Reartes Guillermo 2013-06-03 14:30:48 EDT
Issue #3: 'group list' does not shown any installed group

System with 'group_command=objects'

# yum group list installed
Loaded plugins: langpacks, refresh-packagekit
Warning: no environments/groups match: installed


System with 'group_command=compat'

# yum group list installed
Loaded plugins: langpacks, refresh-packagekit
Installed environment groups:
   Infrastructure Server
   Minimal Install
Installed groups:
   Administration Tools
   Authoring and Publishing
   Cloud Infrastructure
   Design Suite
   Development Tools
   Editors
   Educational Software
   Electronic Lab
   Network Servers
   Office/Productivity
   Robotics
   Security Lab
   Sound and Video
   System Tools
   Text-based Internet
   Window Managers
Done

The issue disappears if one setups yum.conf setting 'group_command=compat'
and then retries the group list action.

Reported in:

* Bug 970214 
  yum group list does not shown any installed group
Comment 4 Reartes Guillermo 2013-06-03 14:31:10 EDT
Issue #4: 'group info' out differs between 'compat' and 'objects' 
(it might not be an issue)

# yum group virtualization info 

Output differes from compat to objects

system with 'group_command=objects'

# yum group info virtualization
Loaded plugins: langpacks, refresh-packagekit

Group: Virtualization
 Group-Id: virtualization
 Description: These packages provide a virtualization environment.
 Mandatory Packages:
   =virt-install
 Default Packages:
   =libvirt
   =qemu-kvm
   =virt-manager
   =virt-viewer
 Optional Packages:
   -guestfs-browser
   -libguestfs-tools
   -python-libguestfs
   -virt-top

system with 'group_command=compat'

# yum group info virtualization
Loaded plugins: langpacks, refresh-packagekit

Group: Virtualization
 Group-Id: virtualization
 Description: These packages provide a virtualization environment.
 Mandatory Packages:
   virt-install
 Default Packages:
   libvirt
   qemu-kvm
   virt-manager
   virt-viewer
 Optional Packages:
   guestfs-browser
   libguestfs-tools
   python-libguestfs
   virt-top


Reported in:

* NONE, I do not reported this. I am not sure this is bad.
Comment 5 Fedora End Of Life 2015-01-09 13:18:52 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 6 Fedora End Of Life 2015-02-17 10:26:33 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.